searchData={"items":[{"type":"module","title":"Hush.Provider.AwsSecretsManager","doc":"Implements a Hush.Provider behaviour to resolve secrets from\nAWS Secrets Manager at runtime.\n\nTo configure this provider, ensure you configure ex_aws and hush:\n\n    config :ex_aws,\n      access_key_id: [{:system, \"AWS_ACCESS_KEY_ID\"}],\n      secret_access_key: [{:system, \"AWS_SECRET_ACCESS_KEY\"}]\n\n    config :hush,\n      providers: [Hush.Provider.AwsSecretsManager]","ref":"Hush.Provider.AwsSecretsManager.html"},{"type":"extras","title":"AWS Secrets Manager Hush Provider","doc":"# AWS Secrets Manager Hush Provider\n\n[![Build Status](https://img.shields.io/github/actions/workflow/status/gordalina/hush_aws_secrets_manager/ci.yml?branch=main&style=flat-square)](https://github.com/gordalina/hush_aws_secrets_manager/actions?query=workflow%3A%22ci%22)\n[![Coverage Status](https://img.shields.io/codecov/c/github/gordalina/hush_aws_secrets_manager?style=flat-square)](https://app.codecov.io/gh/gordalina/hush_aws_secrets_manager)\n[![hex.pm version](https://img.shields.io/hexpm/v/hush_aws_secrets_manager?style=flat-square)](https://hex.pm/packages/hush_aws_secrets_manager)\n[![hex.pm downloads](https://img.shields.io/hexpm/dt/hush_aws_secrets_manager?style=flat-square)]([LICENSE](https://hex.pm/packages/hush_aws_secrets_manager))\n\nThis package provides a [Hush](https://github.com/gordalina/hush) Provider to resolve Amazon Web Services's [Secrets Manager](https://aws.amazon.com/secrets-manager/) secrets.\n\nDocumentation can be found at [https://hexdocs.pm/hush_aws_secrets_manager](https://hexdocs.pm/hush_aws_secrets_manager).","ref":"readme.html"},{"type":"extras","title":"Installation - AWS Secrets Manager Hush Provider","doc":"The package can be installed by adding `hush_aws_secrets_manager` to your list\nof dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:hush, \"~> 1.0\"},\n    {:hush_aws_secrets_manager, \"~> 1.1\"}\n  ]\nend\n```\n\nThis module relies on `ex_aws` to talk to the AWS API. As such you need to configure it, below is an example, but you can read alternative ways of configuring it in [their documentation](https://github.com/ex-aws/ex_aws).\n\nAs the provider needs to start `ex_aws` application, it needs to registered as a provider in `hush`, so that it gets loaded during startup.\n\n```elixir\n# config/config.exs\n\nalias Hush.Provider.AwsSecretsManager\n\nconfig :ex_aws,\n  access_key_id: [{:system, \"AWS_ACCESS_KEY_ID\"}],\n  secret_access_key: [{:system, \"AWS_SECRET_ACCESS_KEY\"}]\n\n# ensure hush loads AwsSecretsManager during startup\nconfig :hush,\n  providers: [AwsSecretsManager]\n```","ref":"readme.html#installation"},{"type":"extras","title":"AWS Authorization - AWS Secrets Manager Hush Provider","doc":"In order to retrieve secrets from AWS, ensure the service account you use has a similar policy as:\n\n```json\n{\n  \"Version\": \"2012-10-17\",\n  \"Statement\": [\n    {\n      \"Effect\": \"Allow\",\n      \"Action\": \"secretsmanager:GetSecretValue\",\n      \"Resource\": [\n        \"arn:aws:secretsmanager: : :secret: \",\n        \"arn:aws:secretsmanager:us-east-1:000000000000:secret:config/password-MzBAO2\"\n      ]\n    }\n  ]\n}\n```","ref":"readme.html#aws-authorization"},{"type":"extras","title":"Usage - AWS Secrets Manager Hush Provider","doc":"The following example reads the password and the pool size for CloudSQL from secret manager into the ecto repo configuration.\n\n```elixir\n# config/prod.exs\n\nalias Hush.Provider.AwsSecretsManager\n\nconfig :app, App.Repo,\n  password: {:hush, AwsSecretsManager, \"CLOUDSQL_PASSWORD\"},\n  pool_size: {:hush, AwsSecretsManager, \"ECTO_POOL_SIZE\", cast: :integer, default: 10}\n```","ref":"readme.html#usage"},{"type":"extras","title":"License - AWS Secrets Manager Hush Provider","doc":"Hush is released under the Apache License 2.0 - see the [LICENSE](LICENSE) file.","ref":"readme.html#license"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"v1.1.0 - Changelog","doc":"- Add support for Elixir 1.17 and OTP 27\n- Drop support for Elixir 1.10","ref":"changelog.html#v1-1-0"},{"type":"extras","title":"v1.0.0 - Changelog","doc":"- Add support for hush 1.0.0","ref":"changelog.html#v1-0-0"},{"type":"extras","title":"v0.2.0 - Changelog","doc":"- Add hackney as a hard dependency","ref":"changelog.html#v0-2-0"},{"type":"extras","title":"v0.1.0 - Changelog","doc":"- Announced public release","ref":"changelog.html#v0-1-0"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,48]}}